// Constantes et structures ... 
#define _GNU_SOURCE
#include <getopt.h>

#define Auteur "Olivier Delhomme"
#define Date "2002"
#define Licence "GPL"
#define Version "0.1.1"

#define BINAIRE 0
#define TEXTE 1
#define INCONNU 2
#define ERREUR 3

#define MAX_RANGE 127

#define SELECTED 2   // Something != 0
#define NONE 314159  // round(pi*10000)

// Autres constantes.
#define TRUE 0
#define FALSE 1


typedef struct
{
  int aff_ext;
  int nb_cols;
  int aff_check;
} Options;


static struct option const long_options[] =
{
  {"version", no_argument, NULL, 'v'},
  {"help",no_argument, NULL, 'h'},
  {"display",no_argument, NULL, 'd'},
  {"check", optional_argument, NULL, 'c'},
  {"extended",no_argument, NULL, 'e'},
  {NULL, 0, NULL, 0}
};


struct asciit
{
  int type;
  char *desc;
};

/*
{BINAIRE,""},
{TEXTE,""},
*/

static struct asciit const ascii[] =
{
  {BINAIRE,"NUL (null)"},
  {BINAIRE,"SOH (start of heading)"},
  {BINAIRE,"STX (start of text)"},
  {BINAIRE,"ETX (end of text)"},
  {BINAIRE,"EOT (end of transmission)"},
  {BINAIRE,"ENQ (enquiry)"},
  {BINAIRE,"ACK (acknowledge)"},
  {BINAIRE,"BEL (bell)"},
  {TEXTE,"BS  (backspace)"},
  {TEXTE,"TAB (horizontal tab)"},
  {TEXTE,"LF  (NL line feed, new line)"},
  {TEXTE,"VT  (vertical tab)"},
  {TEXTE,"FF  (NP form feed, new page)"},
  {TEXTE,"CR  (carriage return)"},
  {BINAIRE,"SO  (shift out)"},
  {BINAIRE,"SI  (shift in)"},
  {BINAIRE,"DLE (data link escape)"},
  {BINAIRE,"DC1 (device control 1)"},
  {BINAIRE,"DC2 (device control 2)"},
  {BINAIRE,"DC3 (device control 3)"},
  {BINAIRE,"DC4 (device control 4)"},
  {BINAIRE,"NAK (negative acknowledge)"},
  {BINAIRE,"SYN (synchronous idle)"},
  {BINAIRE,"ETB (end of transmission block)"},
  {BINAIRE,"CAN (cancel)"},
  {BINAIRE,"EM  (end of medium)"},
  {BINAIRE,"SUB (substitute)"},
  {TEXTE,"ESC (escape)"},
  {BINAIRE,"FS  (file separator)"},
  {BINAIRE,"GS  (group separator)"},
  {BINAIRE,"RS  (record separator)"},
  {BINAIRE,"US  (unit separator)"},

  {TEXTE," "},
  {TEXTE,"!"},
  {TEXTE,"\""},
  {TEXTE,"#"},
  {TEXTE,"$"},
  {TEXTE,"%"},
  {TEXTE,"&"},
  {TEXTE,"'"},
  {TEXTE,"("},
  {TEXTE,")"},
  {TEXTE,"*"},
  {TEXTE,"+"},
  {TEXTE,","},
  {TEXTE,"-"},
  {TEXTE,"."},
  {TEXTE,"/"},
  {TEXTE,"0"},
  {TEXTE,"1"},
  {TEXTE,"2"},
  {TEXTE,"3"},
  {TEXTE,"4"},
  {TEXTE,"5"},
  {TEXTE,"6"},
  {TEXTE,"7"},
  {TEXTE,"8"},
  {TEXTE,"9"},
  {TEXTE,":"},
  {TEXTE,";"},
  {TEXTE,"<"},
  {TEXTE,"="},
  {TEXTE,">"},
  {TEXTE,"?"},

  {TEXTE,"@"},
  {TEXTE,"A"},
  {TEXTE,"B"},
  {TEXTE,"C"},
  {TEXTE,"D"},
  {TEXTE,"E"},
  {TEXTE,"F"},
  {TEXTE,"G"},
  {TEXTE,"H"},
  {TEXTE,"I"},
  {TEXTE,"J"},
  {TEXTE,"K"},
  {TEXTE,"L"},
  {TEXTE,"M"},
  {TEXTE,"N"},
  {TEXTE,"O"},
  {TEXTE,"P"},
  {TEXTE,"Q"},
  {TEXTE,"R"},
  {TEXTE,"S"},
  {TEXTE,"T"},
  {TEXTE,"U"},
  {TEXTE,"V"},
  {TEXTE,"W"},
  {TEXTE,"X"},
  {TEXTE,"Y"},
  {TEXTE,"Z"},
  {TEXTE,"["},
  {TEXTE,"\\"},
  {TEXTE,"]"},
  {TEXTE,"^"},
  {TEXTE,"_"},

  {TEXTE,"`"},
  {TEXTE,"a"},
  {TEXTE,"b"},
  {TEXTE,"c"},
  {TEXTE,"d"},
  {TEXTE,"e"},
  {TEXTE,"f"},
  {TEXTE,"g"},
  {TEXTE,"h"},
  {TEXTE,"i"},
  {TEXTE,"j"},
  {TEXTE,"k"},
  {TEXTE,"l"},
  {TEXTE,"m"},
  {TEXTE,"n"},
  {TEXTE,"o"},
  {TEXTE,"p"},
  {TEXTE,"q"},
  {TEXTE,"r"},
  {TEXTE,"s"},
  {TEXTE,"t"},
  {TEXTE,"u"},
  {TEXTE,"v"},
  {TEXTE,"w"},
  {TEXTE,"x"},
  {TEXTE,"y"},
  {TEXTE,"z"},
  {TEXTE,"{"},
  {TEXTE,"|"},
  {TEXTE,"}"},
  {TEXTE,"~"},
  {BINAIRE,"DEL"}


};
